//-----------------------------------------
// LScript Modeler template
//
// Copyright 2005 Michael Green
// MikesLscripts@shortbutpurple.fsnet.co.uk
//

myversion=1.1;

//V1.1
// fixed bug and made generic, to work in both modeler or as a generic plugin.

//V1
// First full version!

@version 2.2
@warnings
@name MGMTLExporter
@script generic
// global values go here

gsurfpntr;
gspecch=1;
glum=1;
gvmap=nil;
glastimagedir=nil;

setsurfpntr
{
    asurf[1]="Aname";
    asurf[2]=@SURFCOLR,SURFLUMI,SURFDIFF,SURFSPEC,SURFGLOS,SURFREFL,
            SURFTRAN,SURFRIND,SURFTRNL,SURFBUMP,SURFSMAN,SURFSIDE@;
    asurf[3]=@nil,SURFAVAL,SURFBUF1,SURFBUF2,SURFBUF3,SURFBUF4,SURFGLOW,
            SURFGVAL,SURFLINE,SURFLCOL,SURFLSIZ,nil,SURFVCOL,
            SURFCLRH,SURFCLRF,SURFADTR,SURFSHRP,nil@;
            //SURFALCH SURFVMAP SURFFSTF are made up (for future proofing)!
    asurf[4]=@nil,SURFRIMG,SURFRSAN,SURFRBLR,
            nil,SURFTIMG,SURFTSAN,SURFTBLR@;
            //SURFROPT,SURFTOPT, are made up and you can't assign to images!
    return(asurf);
}

setupsurface
{
    mysurf;

//  mtlarray is as follows
    mysurf[1] ="Default";

//Basic Tab
    mysurf[2][1]    = <.8,.8,.8>;   // = Colour             (vector or string)
    mysurf[2][2]    = 0.0;          // = Luminosity         (float or string)
    mysurf[2][3]    = 1.0;          // = Diffuse            (float or string)
    mysurf[2][4]    = 0.0;          // = Specular           (float or string)
    mysurf[2][5]    = 0.4;          // = Glossiness         (float or string)
    mysurf[2][6]    = 0.0;          // = Reflection         (float or string)
    mysurf[2][7]    = 0.0;          // = Transparency       (float or string)
    mysurf[2][8]    = 1.0;          // = Refraction Index   (float or string)
    mysurf[2][9]    = 0.0;          // = Translucency       (float or string)
    mysurf[2][10]   = 1.0;          // = Bump               (float or string)
    mysurf[2][11]   = 89.9;         // = Smoothing Angle    (float)
    mysurf[2][12]   = 0;            // = Double sided       (bool)

//Advanced tab
    mysurf[3][1]    = 3;            // = Alpha channel        (int)
    mysurf[3][2]    = 1.0;          // = Alpha Value          (float)
    mysurf[3][3]    = 0;            // = Special Buffer 1     (float)
    mysurf[3][4]    = 0;            // = Special Buffer 2     (float)
    mysurf[3][5]    = 0;            // = Special Buffer 3     (float)
    mysurf[3][6]    = 255;          // = Special Buffer 4     (float)
    mysurf[3][7]    = 0;            // = Glow on              (bool)
    mysurf[3][8]    = 0.0;          // = Glow Intensity       (float)
    mysurf[3][9]    = 0;            // = Render Outlines      (bool)
    mysurf[3][10]   = <0,0,0>;      // = Outline Colour       (Vector)
    mysurf[3][11]   = 1.0;          // = Line size            (float)
    mysurf[3][12]   = nil;          // = VertexColourMap      (string)
    mysurf[3][13]   = 1.0;          // = VertexColouring      (float)
    mysurf[3][14]   = 0.0;          // = Colour Highlights    (float)
    mysurf[3][15]   = 0.0;          // = Colour Filter        (float)
    mysurf[3][16]   = 0.0;          // = Additive transparency(float)
    mysurf[3][17]   = 0.0;          // = Diffuse Sharpness    (float)
    mysurf[3][18]   = 0;            // = Add FastFresnelShader(bool)

// Environment tab
    mysurf[4][1]    = 2;            // = Reflection Options   (int)
    mysurf[4][2]    = nil;          // = Reflection Map       (string)
    mysurf[4][3]    = 0.0;          // = Image Seam Angle     (float)
    mysurf[4][4]    = 0.0;          // = Reflection blurring (float)
    mysurf[4][5]    = 2;            // = Refraction Options   (int)
    mysurf[4][6]    = nil;          // = Refraction Map       (string)
    mysurf[4][7]    = 0.0;          // = Image Seam Angle     (float)
    mysurf[4][8]    = 0.0;          // = Refraction blurring  (float)

//Basic textures
    mysurf[5][1]    = nil;          // = Colour             (string)
    mysurf[5][2]    = nil;          // = Luminosity         (string)
    mysurf[5][3]    = nil;          // = Diffuse            (string)
    mysurf[5][4]    = nil;          // = Specular           (string)
    mysurf[5][5]    = nil;          // = Glossiness         (string)
    mysurf[5][6]    = nil;          // = Reflection         (string)
    mysurf[5][7]    = nil;          // = Transparency       (string)
    mysurf[5][8]    = nil;          // = Refraction Index   (string)
    mysurf[5][9]    = nil;          // = Translucency       (string)
    mysurf[5][10]   = nil;          // = Bump               (string)

    return(mysurf);
}

generic
{
    main();
}

main
{
    // requester code goes here
    myfilename=globalrecall("MGMTLExportFilename","*.mtl");
    mylum=globalrecall("MGMTLExportLum",1).asInt();


    reqbegin("MGMTLExporter ver:"+myversion);

    c0 = ctlfilename("Save MTL to:",myfilename,30,0);
    c1 = ctlchoice("Use as Specular",1,@"Specular","Reflectivity"@);
    c2 = ctlcheckbox("Assign Ambient to Luminosity",mylum);

    return if !reqpost();

    // get requester control values here
    myfilename=getvalue(c0);
    mychoice=getvalue(c1);
    mylum=getvalue(c2);
    reqend();

    // processing code goes here
    if(myfilename)
    {
        globalstore("MGMTLExportFilename",myfilename);
        globalstore("MGMTLExportLum",mylum);
        writemtl(myfilename,mychoice,mylum);
        info("MTL exported");
    }

}


writemtl:pfilename,pchoice,plum
{
    pfile=File(pfilename,"w");

    pfile.writeln(STRING,"#################################################");
    pfile.writeln(STRING,"##             MTL File created by             ##");
    pfile.writeln(STRING,"##                Michael Green                ##");
    pfile.writeln(STRING,"##      Lscripts@shortbutpurple.fsnet.co.uk    ##");
    pfile.writeln(STRING,"#################################################");

//debug();

    mymesh=Mesh(0);
    mysurfnames=Surface(mymesh);

    for(i=1;i<=mysurfnames.size();i++)
    {
        pfile.writeln(STRING," ");

        myfullname=mysurfnames[i];
        mysurf=Surface(mymesh,myfullname);
        mynewname=replacespaces(myfullname);

        mystring="newmtl "+mynewname;
        pfile.writeln(STRING,mystring);
// colour
        myvalue=mysurf.getValue(SURFCOLR);
        mystring="Kd "+myvalue.x.asStr()+" "+myvalue.y.asStr()+" "+myvalue.z.asStr();
        pfile.writeln(STRING,mystring);
// ambient
        myvalue=mysurf.getValue(SURFLUMI);
        mystring="Ka "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// Specular
        if(pchoice==1)
            myvalue=mysurf.getValue(SURFSPEC);
        else
            myvalue=mysurf.getValue(SURFREFL);
        mystring="Ks "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// Glossiness
        myvalue=round(100*mysurf.getValue(SURFGLOS),0);
        mystring="Ns "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// Transparency
        myvalue=1- mysurf.getValue(SURFTRAN);
        mystring="d "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// IOR
        myvalue=mysurf.getValue(SURFRIND);
        mystring="Ni "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// Colourfilter/TransmissionFilter
        myvalue=mysurf.getValue(SURFCLRF);
        mystring="Tf "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// Reflection blurring
        myvalue=round(100*mysurf.getValue(SURFRBLR),0);
        mystring="sharpness "+myvalue.asStr();
        pfile.writeln(STRING,mystring);
// Maps

        pfile.writeln(STRING," ");

//colour
        mymap=getfirstimage(mysurf,SURFCOLR);
        if(mymap)
        {
            myimage=mymap.filename(0);
            mystring="map_Kd "+myimage;
            pfile.writeln(STRING,mystring);
        }

//ambient/Luminosity
        mymap=getfirstimage(mysurf,SURFLUMI);
        if(plum && mymap)
        {
            myimage=mymap.filename(0);
            mystring="map_Ka "+myimage;
            pfile.writeln(STRING,mystring);
        }

//Spec
        if(pchoice==1)
            mymap=getfirstimage(mysurf,SURFSPEC);
        else
            mymap=getfirstimage(mysurf,SURFREFL);

        if(mymap)
        {
            myimage=mymap.filename(0);
            mystring="map_Ks "+myimage;
            pfile.writeln(STRING,mystring);
        }

//Gloss
        mymap=getfirstimage(mysurf,SURFGLOS);
        if(mymap)
        {
            myimage=mymap.filename(0);
            mystring="map_Ns -imfchan l "+myimage;
            pfile.writeln(STRING,mystring);
        }

//Trans
        mymap=getfirstimage(mysurf,SURFTRAN);
        if(mymap)
        {
            myimage=mymap.filename(0);
            mystring="map_d -imfchan l "+myimage;
            pfile.writeln(STRING,mystring);
        }

//Bump
        mymap=getfirstimage(mysurf,SURFBUMP);
        if(mymap)
        {
            myimage=mymap.filename(0);
            mystring="map_bump -bmp l.0 "+myimage;
            pfile.writeln(STRING,mystring);
        }

//Refl  <================= LScript calls are buggy....
//debug();
//         if(mysurf.getValue(SURFRIMG))
//         {
//             mymap=mysurf.getValue(SURFRIMG);
//             myimage=mymap.filename(0);
//             mystring="refl -type sphere "+myimage;
//             pfile.writeln(STRING,mystring);
//         }

    }

}

replacespaces:pstring
{
        mynamebits=parse(" ",pstring);
        newname=mynamebits[1];
        for(i=2;i<=mynamebits.size();i++)
        {
            newname=newname+"_" + mynamebits[i];
        }

        return(newname);
}

getfirstimage:psurface,pchannel
{
//debug();
    myTOA=psurface.getTexture(pchannel);
    if(!myTOA)
        return(nil);
    mytexture=myTOA.firstLayer();
    while(mytexture && mytexture.type!=TXTRIMAGE && mytexture.getValue(TXLRIMAGE)==nil)
    {
        mytexture=myTOA.nextLayer(mytexture);
    }
    if(mytexture)
    {
        myimage=mytexture.getValue(TXLRIMAGE);
    }
    return(myimage);
}
