//-----------------------------------------
// LScript Modeler template
//
// Copyright 2005 Michael Green
// MikesLscripts@shortbutpurple.fsnet.co.uk
//

myversion=1.6;

//v1.6
// worked around bug in layout.
//v1.5
// Changed how images are loaded so it should be a quicker process for loading mulitply
// referenced images.
//v1.4
// Add a get name from texture option for mtl files which give odd surface names.
//v1.3
//fixed crash bug in loadtexture and made generic - can be used in modeler or as a generic ls
//v1.2
//Replaced mybits[mybits.size()) with getfilename(mybits) in parseMTL
// so if the parameters are out of order, it'll still find the image maps.
//V1.1
// Now remembers last image loaded directory.
//V1
// First full version!

@version 2.2
@warnings

//========================================================================================

// for modeler script, main section is called main
// @//script modeler
// main
// {
// 	options();
// }
//
// CheckObject       // Modeler version.
// {
// 	mymesh=Mesh(0);
// 	return(mymesh);
// }

//for generic script, main section is called generic, and renamesurfaces crashes layout
@script generic
generic
{
	options();
}

CheckObject          // generic version
{
	mymesh=Scene().firstSelect();
	if(!mymesh || mymesh.genus!=MESH || mymesh.null)
		return(nil);
	myfile=mymesh.filename;
	mysplit=split(myfile);
	if(mysplit[4]!=".lwo")
	{
		mynew=mysplit[3]+".lwo";
		myfilename=getfile("Save .obj as .lwo called:",mynew,mysplit[1]+mysplit[2],0);
		if(!myfilename)
			return(nil);
		else
			SaveObject(myfilename);
 	}
 	return(mymesh);
}

//========================================================================================

gsurfpntr;
gspecch=1;
glum=1;
gvmap=nil;
glastimagedir=nil;



setsurfpntr
{
    asurf[1]="Aname";
    asurf[2]=@SURFCOLR,SURFLUMI,SURFDIFF,SURFSPEC,SURFGLOS,SURFREFL,
            SURFTRAN,SURFRIND,SURFTRNL,SURFBUMP,SURFSMAN,SURFSIDE@;
    asurf[3]=@nil,SURFAVAL,SURFBUF1,SURFBUF2,SURFBUF3,SURFBUF4,SURFGLOW,
            SURFGVAL,SURFLINE,SURFLCOL,SURFLSIZ,nil,SURFVCOL,
            SURFCLRH,SURFCLRF,SURFADTR,SURFSHRP,nil@;
            //SURFALCH SURFVMAP SURFFSTF are made up (for future proofing)!
    asurf[4]=@nil,SURFRIMG,SURFRSAN,SURFRBLR,
            nil,SURFTIMG,SURFTSAN,SURFTBLR@;
            //SURFROPT,SURFTOPT, are made up and you can't assign to images!
    return(asurf);
}

setupsurface
{
    mysurf;

//  mtlarray is as follows
    mysurf[1] ="Default";

//Basic Tab
    mysurf[2][1]    = <.8,.8,.8>;   // = Colour             (vector or string)
    mysurf[2][2]    = 0.0;          // = Luminosity         (float or string)
    mysurf[2][3]    = 1.0;          // = Diffuse            (float or string)
    mysurf[2][4]    = 0.0;          // = Specular           (float or string)
    mysurf[2][5]    = 0.4;          // = Glossiness         (float or string)
    mysurf[2][6]    = 0.0;          // = Reflection         (float or string)
    mysurf[2][7]    = 0.0;          // = Transparency       (float or string)
    mysurf[2][8]    = 1.0;          // = Refraction Index   (float or string)
    mysurf[2][9]    = 0.0;          // = Translucency       (float or string)
    mysurf[2][10]   = 1.0;          // = Bump               (float or string)
    mysurf[2][11]   = 89.9;         // = Smoothing Angle    (float)
    mysurf[2][12]   = 0;            // = Double sided       (bool)

//Advanced tab
    mysurf[3][1]    = 3;            // = Alpha channel        (int)
    mysurf[3][2]    = 1.0;          // = Alpha Value          (float)
    mysurf[3][3]    = 0;            // = Special Buffer 1     (float)
    mysurf[3][4]    = 0;            // = Special Buffer 2     (float)
    mysurf[3][5]    = 0;            // = Special Buffer 3     (float)
    mysurf[3][6]    = 255;          // = Special Buffer 4     (float)
    mysurf[3][7]    = 0;            // = Glow on              (bool)
    mysurf[3][8]    = 0.0;          // = Glow Intensity       (float)
    mysurf[3][9]    = 0;            // = Render Outlines      (bool)
    mysurf[3][10]   = <0,0,0>;      // = Outline Colour       (Vector)
    mysurf[3][11]   = 1.0;          // = Line size            (float)
    mysurf[3][12]   = nil;          // = VertexColourMap      (string)
    mysurf[3][13]   = 1.0;          // = VertexColouring      (float)
    mysurf[3][14]   = 0.0;          // = Colour Highlights    (float)
    mysurf[3][15]   = 0.0;          // = Colour Filter        (float)
    mysurf[3][16]   = 0.0;          // = Additive transparency(float)
    mysurf[3][17]   = 0.0;          // = Diffuse Sharpness    (float)
    mysurf[3][18]   = 0;            // = Add FastFresnelShader(bool)

// Environment tab
    mysurf[4][1]    = 2;            // = Reflection Options   (int)
    mysurf[4][2]    = nil;          // = Reflection Map       (string)
    mysurf[4][3]    = 0.0;          // = Image Seam Angle     (float)
    mysurf[4][4]    = 0.0;          // = Reflection blurring (float)
    mysurf[4][5]    = 2;            // = Refraction Options   (int)
    mysurf[4][6]    = nil;          // = Refraction Map       (string)
    mysurf[4][7]    = 0.0;          // = Image Seam Angle     (float)
    mysurf[4][8]    = 0.0;          // = Refraction blurring  (float)

//Basic textures
    mysurf[5][1]    = nil;          // = Colour             (string)
    mysurf[5][2]    = nil;          // = Luminosity         (string)
    mysurf[5][3]    = nil;          // = Diffuse            (string)
    mysurf[5][4]    = nil;          // = Specular           (string)
    mysurf[5][5]    = nil;          // = Glossiness         (string)
    mysurf[5][6]    = nil;          // = Reflection         (string)
    mysurf[5][7]    = nil;          // = Transparency       (string)
    mysurf[5][8]    = nil;          // = Refraction Index   (string)
    mysurf[5][9]    = nil;          // = Translucency       (string)
    mysurf[5][10]   = nil;          // = Bump               (string)

    return(mysurf);
}

options
{
    gsurfpntr=setsurfpntr();
    mymesh=CheckObject();
    if(!mymesh)
    {
        error("Please select a mesh.");
        return;
    }

    i=2;
    myvmaplist[1]="(none)";
    myvmap=VMap(VMTEXTURE);
    while(myvmap)
    {
        if(myvmap.type==VMTEXTURE)
        {
            myvmaplist[i]=myvmap.name;
            i++;
        }
        myvmap=myvmap.next();
    }

    myfilename=globalrecall("MGMTLExportFilename","*.mtl");
    glum=globalrecall("MGMTLExportLum",1).asInt();
    glastimagedir=globalrecall("MGMTLExportLastimage",getdir("Images"));
    myname=recall("MGMTLExportName",0);

    reqbegin("MG MTL Material Importer Ver:"+myversion);

    f1 = ctlfilename("Load MTL from:",myfilename,30,1);
    c0 = ctlchoice("Assign specular to ",gspecch,@"specular","reflectivity","both"@);
    c1 = ctlpopup("UVmap for textures",1,myvmaplist);
    c2 = ctlcheckbox("Assign Ambient to Luminosity",glum);
    if(runningUnder()==MODELER)
    	c3 = ctlcheckbox("Use first image name as surface name",myname);

    return if !reqpost();

    // get requester control values here
    myfilename=getvalue(f1);
    gspecch=getvalue(c0);
    myvmapno=getvalue(c1);
    glum=getvalue(c2);
    if(runningUnder()==MODELER)
    	myname=getvalue(c3);
    else
		myname=0;

    reqend();
//debug();
    // processing code goes here

    if(myvmapno>1)
        gvmap=VMap(VMTEXTURE,myvmaplist[myvmapno]);

    if(!myfilename)
        error("Please choose a MTL file");
    myfile=File(myfilename,"r");
    if(!myfile)
        error("Please choose a MTL file");


    globalstore("MGMTLExportFilename",myfilename);
    globalstore("MGMTLExportLum",glum);
    store("MGMTLExportName",myname);

	mymtls=parsemtlfile(myfile);
    if(!mymtls)
        error("Material file was not readable");
    info("Loaded materials");
    copymtls2surfs(mymtls,mymesh,myname);
    info("Materials applied");

    globalstore("MGMTLExportLastimage",glastimagedir);
}

findimages:pmtls
{
    defaultmat=setupsurface();  // a material for default properties.

    myimlist=nil;
    myimagepair;
    // go through material list and find actual images and make them into ImageAgents of all images used.
    total=1;
//    make a list of images used.
    for(i=1;i<=pmtls.size();i++)   // go through each material.
    {
    	for(f=4;f<=5;f++)
    	{
            for(a=1;a<=pmtls[i][f].size();a++)
            {
                if(pmtls[i][f][a] && pmtls[i][f][a].isStr())
                {
					myimlist[total]=pmtls[i][f][a];
					total++;
                }
            }
        }
    }
//debug();

    myimlist.sortA();
    myimlist.reduce();
    myimlist.trunc();
    myimageagents;
    for(i=1;i<=myimlist.size();i++)
    {
    	myimageagents[i]=getimage(myimlist[i]);
	}
//	debug();
	
	for(i=1;i<=pmtls.size();i++)   // go through each material.
	{
    	for(f=4;f<=5;f++)
    	{
	        for(a=1;a<=pmtls[i][f].size();a++)  // do the basic tab.
	        {
	            if(pmtls[i][f][a] && pmtls[i][f][a].isStr())
	            {
					myimagename=pmtls[i][f][a];
					for(j=1;j<=myimlist.size();j++)
					{
						if(myimagename==myimlist[j])
						{
							pmtls[i][f][a]=myimageagents[j];
						}
					}
	            }
	        }
	    }
	}
    return(pmtls);
}

getimage:pfilename
{
//    warn(glastimagedir);
    myimage=loadimage(pfilename);
    temp=split(pfilename);
    myimagename=temp[3]+temp[4];
    if(temp[1]&&temp[2])
    	mypath=temp[1]+temp[2];

    if(!myimage && glastimagedir)    // still no joy... try the last image directory?
    {
        mypath=glastimagedir;
        myimage=loadimage(mypath +myimagename);
    }

    if(!myimage)   // try looking in the directory of the mesh.
    {
        mymesh=Mesh(0);
        mymeshname=mymesh.filename;
        if(mymeshname)
        {
            mymeshpath=split(mymeshname);
            mypath=mymeshpath[1]+mymeshpath[2];
            myfilename=mypath+myimagename;
            myimage=loadimage(myfilename);
        }
    }

    if(!myimage)    // still no joy... try the images directory?
    {
        mypath=getdir("Images");
        myimage=loadimage(mypath + "\\" +myimagename);
    }
    if(!myimage) // finally ask the user for image file.
    {  
        mypath=glastimagedir;
        myfile=getfile("Choose image "+myimagename,myimagename,mypath,1);
        if(myfile)
        {
            myimage=loadimage(myfile);
            temp=split(myfile);
            glastimagedir=temp[1]+temp[2];
        }
    }
//debug();



    return(myimage);
}

copymtls2surfs:pmtls,pmesh,pname
{
    mymesh=Mesh(0);
    //find all images.
    mynewmtls=findimages(pmtls);
    for(i=1;i<=pmtls.size();i++)
    {
        mymtl=pmtls[i];
        mysurf=Surface(mymesh,mymtl[1]);
        copymtl(mymtl,mysurf,gvmap,pname);

        //rename surface to first image name.
        if(pname)
        {
            myname=nil;
            for(j=1;j<=10;j++)
            {
                if(!myname&&mymtl[5][j])
                {
                    myname=mymtl[5][j].name;
                    break;
                }
            }
            if(myname!=nil)
            {
                temp=split(myname);
                newname=temp[3];
                surfname=mysurf.name;
                renamesurface(surfname,newname);
            }
        }
    }
//    renamesurface(newname,newname);  // do this to get round a bug in renamesurface.
}

copymtl:pmtl,psurf,puvs,pname
{
//debug();
    myname=nil;
    for(i=1;i<=10;i++) // Attributes 1 to 10 are all values or textures
    {
        myatt=gsurfpntr[2][i];
        myval=pmtl[2][i];
        psurf.setValue(myatt,myval);
        if(pmtl[5][i])
        {
            myimage=pmtl[5][i];
            addtexture(psurf,gsurfpntr[2][i],myimage,puvs);
            if(!myname)
                myname=myimage.name;
        }
    }

    psurf.setValue(gsurfpntr[2][11],pmtl[2][11]);
    psurf.setValue(gsurfpntr[2][12],pmtl[2][12]);

    for(i=1;i<=18;i++) // Advanced tab
    {
        myatt=gsurfpntr[3][i];
        myval=pmtl[3][i];
        if(myatt)
            psurf.setValue(myatt,myval);
    }

    for(i=1;i<=8;i++) // Environment tab
    {
        myatt=gsurfpntr[4][i];
        myval=pmtl[4][i];
        if(myatt)
            psurf.setValue(myatt,myval);
    }



// add fastfresnel shader
//    if(pmtl[3][18])
//        ApplyServer(SERVER_SHADER_H,"Fast Fresnel");
// NOTE! CANT DO THIS TO SURFACES! SHAME!

}

addtexture:psurf,pchan,pimage,pvmap
{
//debug();
    mymesh=Mesh(0);
//    info(pchan);
    CommandInput("Surf_SetSurf \"" + psurf.name + "\" \"" + mymesh.name + "\"");
    mycommand="Surf_SetInt "+pchan+" 2";
    CommandInput(mycommand);
    mytxt=psurf.getTexture(pchan);
    mylyr=mytxt.firstLayer();
    if(!mylyr||mylyr.type!=TXTRIMAGE)
        mylyr=mytxt.addLayer(TXTRIMAGE);
    if(pimage)
    {
//debug();
        mylyr.setValue(TXLRIMAGE,pimage);// image
    }
    mylyr.setValue(TXLRPROJECT,TXPJUVMAP);
    mylyr.setValue(TXLROPACITY,1);
    if(pvmap)
    {
        mylyr.setValue(TXLRVMAP,pvmap);// uvmap
    }

}


parsemtlfile:pfile
{
    myfile=pfile;
    mymtls=nil;
    ind=0;
    
//==================================================================================================
//debug();
//==================================================================================================
    while(!myfile.eof())
    {
        myline=myfile.read();
        if(myline!=nil)
        {
            myline.pack();
            mybits=parse(" ",myline);
            mybits.trunc();
            if(mybits[1]=="newmtl")
            {
                ind++;
                mymtls[ind]=setupsurface();
                mymtls[ind][1]=mybits[2];
            }
    //====================================================================================================
    // Basic Attributes.
    // Colour (diffuse in mtl terms)
            if(mybits[1]=="Kd")
            {
                if (mybits[2]=="xyz")
                {
                    if (mybits.size==3)
                        mymtls[ind][2][1]=cie2rgb(mybits[3].asNum(),mybits[3].asNum(),mybits[3].asNum());
                    else
                        mymtls[ind][2][1]=cie2rgb(mybits[3].asNum(),mybits[4].asNum(),mybits[5].asNum());
                }
                else if (mybits[2]=="spectral")
                    mymtls[ind][2][1]=spectral2rgb(mybits[3],mybits[4]);
                else if(mybits.size()==2)   // G and B can be ommitted => r=g=b
                    mymtls[ind][2][1]=<mybits[2].asNum()*255,mybits[2].asNum()*255,mybits[2].asNum()*255>;
                else                        // just use colour values.
                    mymtls[ind][2][1]=<mybits[2].asNum()*255,mybits[3].asNum()*255,mybits[4].asNum()*255>;
            }

    // Ambient/lum
            if(glum && mybits[1]=="Ka")
            {
                myval = chooseval(mybits);
                mymtls[ind][2][2]=myval;
            }

    // Specular
            if(mybits[1]=="Ks")
            {
                myval = chooseval(mybits);
                if(gspecch==1)                      // just does spec channel
                    mymtls[ind][2][4]=myval;
                else if(gspecch==2)                 // just does reflect channel
                    mymtls[ind][2][6]=myval;
                else                                // does both
                {
                    mymtls[ind][2][4]=myval;
                    mymtls[ind][2][6]=myval;
                }
    
            }
    
    //Glossiness
            if(mybits[1]=="Ns")
                mymtls[ind][2][5]=mybits[2].asNum()/100; //????? goes between 0-1000 100 being small highlight.
    
    //Transparency
            if(mybits[1]=="d")
            {
                if(mybits[2]=="-halo")
                {
                    mymtls[ind][3][18]=1; //set fast fresnel flag
                }
                myval = 1-mybits[2].asNum();   //d(dissolve) factor 0=transparent, 1= opaque
                mymtls[ind][2][7]=myval;
            }
    
    //Index of refraction (optical density)
            if(mybits[1]=="Ni")
                mymtls[ind][2][8]=mybits[2].asNum();
    
    //=====================================================================================================
    // Advanced
    // Transmission Filter (Colour Filter)?
            if(mybits[1]=="Tf")
            {
                myval = chooseval(mybits);
                mymtls[ind][3][15]=myval;
            }
    //====================================================================================================
    // Environment
    
            if(mybits[1]=="sharpness")
            {
                mymtls[ind][4][4]=1-(mybits[2].asNum()/100);
            }
    
    
    //===================================================================================================
    // image maps
            // need to find path?
            if(mybits[1]=="map_Kd")
            {
                mymtls[ind][5][1]=findfilename(mybits);
            }

            if(glum && mybits[1]=="map_Ka")
            {
                mymtls[ind][5][2]=findfilename(mybits);
            }

            if(mybits[1]=="map_Ks")
            {
                if(gspecch==1)
                    mymtls[ind][5][4]=findfilename(mybits);
                if(gspecch==2)
                    mymtls[ind][5][6]=findfilename(mybits);
                else
                {
                    mymtls[ind][5][4]=findfilename(mybits);
                    mymtls[ind][5][6]=findfilename(mybits);
                }
            }
            if(mybits[1]=="map_Ns")
            {
                mymtls[ind][5][5]=findfilename(mybits);
            }
            if(mybits[1]=="map_d")
            {
                mymtls[ind][5][7]=findfilename(mybits);
            }
            if(mybits[1]=="bump"||mybits[1]=="map_bump")
            {
                mymtls[ind][5][10]=findfilename(mybits);
            }
            if(mybits[1]=="refl")
            {
                mymtls[ind][4][2]=findfilename(mybits);
            }
        }

    }
    return(mymtls);
}

// end of parser
//===================================================================================================

findfilename:parray
// in an array of strings, finds the first one which has a filename in it
// if no filename, return nil;
{
    myfile=nil;
    for(i=parray.size();i>=1;i--)
    {
        mytemp=parray[i];
        mystring=split(mytemp);
        if(mystring[4])
        {
            myfile=mytemp;
            break;
        }
    }
    return(myfile);
}



chooseval:pbits   // figures out what the value should be
{
    if (pbits[2]=="xyz")
    {
        if (pbits.size==3) // y and z can be omitted => x=y=z
            myval=cie2val(pbits[3].asNum(),pbits[3].asNum(),pbits[3].asNum());
        else
            myval=cie2val(pbits[3].asNum(),pbits[4].asNum(),pbits[5].asNum());
    }
    else if (pbits[2]=="spectral")
        myval=spectral2val(pbits[3],pbits[4]);
    else if (pbits.size()==2)   // G and B can be ommitted => r=g=b
        myval=pbits[2].asNum();
    else
        myval=(pbits[2].asNum()+pbits[3].asNum()+pbits[4].asNum())/3;

    return(myval);
}

cie2rgb: x,y,z
{
//  gotta convert from cie
    return(<x,y,z>);
}

cie2val:x,y,z
{
//  gotta convert from cie
    return((x+y+z)/3);
}

spectral2rgb: file,factor
{
//  gotta convert from spectral?
    return(<1.0,1.0,1.0>);
}

spectral2val: file,factor
{
//  gotta convert from spectral?
    return(1.0);
}


